SystemOrganization addCategory: #GroupManagerUI!

MorphTreeNodeModel subclass: #GroupNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

!GroupNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:46'!
childNodeClassFromItem: anItem

	^ ItemNode! !

!GroupNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:27'!
childrenItems

	^ self item elements! !

!GroupNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/15/2011 14:07'!
isGroup

	^ true! !

!GroupNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:29'!
rowMorphForColumn: aTreeColumn

	^ self item ifNotNil: [:i | i name asMorph] ! !

MorphTreeNodeModel subclass: #ItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

!ItemNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/15/2011 14:07'!
isGroup

	^ false! !

DialogWindow subclass: #DialogGroupManagerUI
	instanceVariableNames: 'groupManager treeModel tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

DialogGroupManagerUI subclass: #DialogGroupAdderUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

!DialogGroupAdderUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 3/15/2011 15:46'!
buildTextMorph

	^ (PluggableTextMorph
		on: self 
		text: #text 
		accept: nil)
		disable;
		height: StandardFonts buttonFont height;
		hResizing: #spaceFill;
		yourself! !

!DialogGroupAdderUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:46'!
elementBox

	^ GroupboxMorph new 
		addContentMorph: self buildTextMorph;
		label: 'Item to add:';
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!DialogGroupAdderUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 3/15/2011 15:46'!
elementToAdd

	^ self groupManager elementToAdd! !

!DialogGroupAdderUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:45'!
newContentMorph

	^(self newColumn: {
			self elementBox.
			self treeBox}) hResizing: #spaceFill! !

!DialogGroupAdderUI methodsFor: 'build items' stamp: 'BenjaminVanRyseghem 3/17/2011 15:11'!
text

	^ self groupManager elementToAdd printString! !

!DialogGroupAdderUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 15:28'!
valid

	self selectedGroup
		ifNotNil: [:group | group add: self elementToAdd]! !

!DialogGroupManagerUI class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 3/17/2011 15:34'!
on: aModel

	^ self basicNew 
		groupManager: aModel;
		initialize.! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:52'!
addAGroup

	
	self groups addAGroup.
	tree updateList.! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:33'!
addAction

	self addAGroup! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:21'!
addLabel
	
	^ 'Create'! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:08'!
addState

	^ true! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 15:11'!
applyChanges

	self valid! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 14:11'!
buildAddButton

	^ (PluggableButtonMorph
			on: self 
			getState: #addState 
			action: #addAction 
			label: #addLabel)
			hResizing: #spaceFill;
			yourself! !

!DialogGroupManagerUI methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 3/15/2011 15:29'!
buildGroupsTree

	tree := (MorphTreeMorph on: self treeModel)
				beSingle;
				autoDeselection: true;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				rowColorForEven: Color lightGray muchLighter odd: Color white.
	tree
		vResizing: #spaceFill;
		hResizing: #spaceFill.

	^ tree buildContents! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 14:11'!
buildRemoveButton

	^ (PluggableButtonMorph
			on: self 
			getState: #removeState 
			action: #removeAction 
			label: #removeLabel)
			hResizing: #spaceFill;
			yourself
! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:34'!
buildRenameButton

	^ (PluggableButtonMorph
			on: self 
			getState: #renameState 
			action: #renameAction 
			label: #renameLabel)
			hResizing: #spaceFill;
			yourself! !

!DialogGroupManagerUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:36'!
groupManager

	^ groupManager! !

!DialogGroupManagerUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 15:11'!
groupManager: aModel

	groupManager := aModel! !

!DialogGroupManagerUI methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 3/15/2011 13:44'!
groups

	^ self groupManager groups! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:32'!
initialExtent

	^  300@400! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:25'!
isResizeable
	^true! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:45'!
newContentMorph

	^(self newColumn: {self treeBox}) hResizing: #spaceFill! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 14:21'!
okButtonAction
	self valid.! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:51'!
removeAGroup

	self groups removeAGroup: self selectedGroup.
	tree updateList! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:33'!
removeAction
	
	self removeAGroup! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:08'!
removeLabel
	
	^ 'Remove'! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 14:08'!
removeState

	^ self selectedGroup notNil! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 15:33'!
renameAction

	self renameGroup! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 18:19'!
renameGroup

	self groups renameAGroup: self selectedGroup.	
	tree updateList.! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 15:34'!
renameLabel

	^ 'Rename'! !

!DialogGroupManagerUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 15:34'!
renameState

	^ self selectedGroup notNil! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 14:19'!
selectedGroup
	
	^ self selectedNode 
		ifNil: [ nil ]
		ifNotNil: [:node |
			node isGroup
				ifTrue: [ node item ]
				ifFalse: [ node parentNode item ]]! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 14:19'!
selectedNode

	^ self treeModel selectedNode! !

!DialogGroupManagerUI methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:35'!
treeBox

	^ GroupboxMorph new 
		addContentMorph: self buildGroupsTree;
		addContentMorph: (self newRow: {self buildAddButton. self buildRenameButton. self buildRemoveButton});
		label: 'Choose a group:';
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!DialogGroupManagerUI methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 3/15/2011 14:19'!
treeModel
	
	^ treeModel ifNil: [treeModel := self treeModelClass new model: self]! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 13:16'!
treeModelClass

	^ GroupCreatorTreeModel! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 14:14'!
updateSelectedNode

	self changed: #removeState! !

!DialogGroupManagerUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 15:48'!
valid! !

MorphTreeModel subclass: #GroupCreatorTreeModel
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

!GroupCreatorTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/15/2011 13:44'!
groups

	^ self model groups! !

!GroupCreatorTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:26'!
groupsManager

	^ self model groupsManager! !

!GroupCreatorTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:39'!
model

	^ model! !

!GroupCreatorTreeModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:39'!
model: anObject

	model := anObject! !

!GroupCreatorTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 15:27'!
rootItems

	^ self groups groups! !

!GroupCreatorTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/15/2011 13:43'!
rootNodeClassFromItem: anItem

	^ GroupNode! !

!GroupCreatorTreeModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/15/2011 14:18'!
selection: aNode

	super selection: aNode.
	self model updateSelectedNode.! !

Object subclass: #DialogGroupManager
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

DialogGroupManager subclass: #DialogGroupAdder
	instanceVariableNames: 'elementToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManagerUI'!

!DialogGroupAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 15:42'!
elementToAdd

	^ elementToAdd! !

!DialogGroupAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 15:42'!
elementToAdd: anObject

	elementToAdd := anObject! !

!DialogGroupAdder methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:47'!
uiClass

	^DialogGroupAdderUI! !

!DialogGroupManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:34'!
groups

	^ groups! !

!DialogGroupManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 13:34'!
groups: anObject

	groups := anObject! !

!DialogGroupManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 15:39'!
open

	(self uiClass on: self) 
		title: 'Group Manager';
		openInWorld! !

!DialogGroupManager methodsFor: 'display' stamp: 'BenjaminVanRyseghem 3/15/2011 13:35'!
uiClass

	^DialogGroupManagerUI! !
